// This code has been made by Nathalie Vis and Daniëlle van Tol.//

PFont f; 
PImage hm;
PImage bg;
PImage ms; 
PImage ka;
PImage kt;
PImage tr;
PImage mn;

PShape normal;
PShape quick;
PShape hard;

PShape cont;
PShape re;
PShape ho;

import ddf.minim.*;
import ddf.minim.effects.*;
import gifAnimation.*; 

Gif myAnimation;

Minim minim; 
AudioPlayer file;
AudioPlayer file2;

//Audio on
boolean audio = true;

//Game start
boolean gameStart = true;

//Game Over
boolean gameOver = false; 

//serial
import processing.serial.*;

int lf = 10;    // Linefeed in ASCII
String myString = null;   // where a string from readStringUntil is stored initially.
Serial myPort;  // The serial port

int totalSensorCount = 2;   // number of sensor values to use
int sensorCount = 2;   // number of sensor values to use
int[] values = new int[sensorCount];  // where neumetic values converted from myString are stored.

void setup(){
  size(1200,760);
  
  //Reading data//
  println(Serial.list());
  myPort = new Serial(this, Serial.list()[0], 9600);  // bps can be 2400, 4800, 9600, 19200, 38400, 57600 and 115200.
  myPort.clear();
  myString = myPort.readStringUntil(lf);
  myString = null;
  
  // modes//
  rectMode(CENTER);
  imageMode(CENTER);
  textAlign(CENTER);
  
  // images //
  hm = loadImage("homex.jpg"); 
  bg = loadImage("xmas2.jpg");
  ms = loadImage("gift2.png");
  ka = loadImage("katx1.png");
  kt = loadImage("katx2.png");
  tr = loadImage("tram2.png");
  mn = loadImage("menu.png");
  
  //gif//
  myAnimation = new Gif(this, "k.gif");
  myAnimation.play();

  // Font //
  f = createFont("Arial", 25, true);
}

// Bol Parameters //
float xbol=600;
float ybol=350;
float dxbol = 3;
float dybol =2;
int straal = 50;

// Peddel Parameters //
float wpeddel= 140;
float hpeddel= 180;
float xpeddel= 100;
float ypeddel= 585;
float dypeddel =0;

float wpeddel2= 140;
float hpeddel2= 180;
float xpeddel2= 1100;
float ypeddel2 = 585;
float dypeddel2= 0;


// music
int music = 0;

// Score
int score1 = 0;
int score2 = 0;

//Pauze
boolean pauze=false;

// Jump
int jump = 0;
int jump1= 0;

// Factor
float factor = 1;

// Down
boolean down = false;
boolean down1 = false;

void draw(){  
  // UPDATING //
  
  // setting music //
  if(gameStart == false && music != 2){
  file2.close();
  minim.stop();
  minim = new Minim(this);
  file = minim.loadFile("On Tiptoe.mp3");
  file.loop();
  music = 2;
  }
  
  if (gameStart == true && music != 1 ){
    if(music!=0){
      file.close();
      minim.stop();
    }
  minim = new Minim(this);
  file2 = minim.loadFile("cat.mp3");
  file2.loop();
  music = 1;
  }
  
  if(pauze==false){
  // Updating Bol Position //
  xbol += dxbol * factor;
  ybol += dybol * factor;
  
  // Updating Peddel position //
  ypeddel += dypeddel;
  ypeddel2 += dypeddel2;

  //Update Jump
  if (values[0] == 25 && jump ==0){
    jump = 2;
  }
  
  if(values[0]<= 24 && jump == 0){
    jump = 2;
  }

  if (values[1] == 25 && jump1 ==0){
    jump1 = 2;
  }
  
  if(values[1]<=24 && jump1 == 0){
    jump1 = 2;
  }

  // Moving peddel //
  if (jump == 2 && down == false){
      dypeddel= -5;
    }
    
  if(ypeddel<200 && jump ==2){
      dypeddel = -dypeddel;
      down = true;
   }
  
  
  if(jump == 1 && down == false){
      dypeddel=-4;
    }
       
  if(ypeddel<350 && jump == 1){
       dypeddel = -dypeddel;
       down = true;
    }



  
  //moving peddel2
   if (jump1 == 2 && down1 == false){
      dypeddel2= -5;
    }
    
  if(ypeddel2<200 && jump1 ==2){
      dypeddel2 = -dypeddel2;
      down1 = true;
   }
  
  
  if(jump1 == 1 && down1 == false){
      dypeddel2=-4;
    }
       
  if(ypeddel2<350 && jump1 == 1){
       dypeddel2 = -dypeddel2;
       down1 = true;
}
  }

  
  // CHECKING //
  
  // Making Side Walls Bounce //  
  if (xbol-straal> width){
    xbol = 600;
    ybol = 350;
    dxbol = -dxbol;
    score1 += 1;
  }
  
   if (xbol+straal<0){
    xbol = 600;
    ybol = 350;
    dxbol = -dxbol;
    score2 += 1;
  }
  
  if (score1==3 || score2==3){
    gameOver=true;
  }
  
  if(keyPressed){
    if(key == ENTER){
    gameOver=false; 
    score1=0;
    score2=0;
    ypeddel=585;
    ypeddel2=585;
    dypeddel=0;
    dypeddel2=0;
    xbol=600;
    ybol=350;
    dxbol = 3;
    dybol =2;
    }
  }
  
  // Making Top Walls Bounce //
  if(ybol+2*straal> 650 || ybol-1*straal<0){
    dybol = -dybol;
  }
  
  // Keeping Peddel in Window //
  if(ypeddel-hpeddel/2 < 0){
    ypeddel = hpeddel/2;
  }
  
  if(ypeddel+hpeddel/2 > height){
    ypeddel = height - hpeddel/2;
  }
  
  // Keeping Peddel2 in Window //
  if(ypeddel2-hpeddel2/2 < 0){
    ypeddel2 = hpeddel2/2;
  }
  
  if(ypeddel2+hpeddel2/2 > height){
    ypeddel2 = height - hpeddel2/2;
  }
  
  // Keeping Peddels above trampoline //
  if (ypeddel > 585){
    ypeddel = 585;
    jump = 0;
    down = false;
  }
  
  if (ypeddel2 > 585){
    ypeddel2 = 585;
    jump1 =0;
    down1 = false;
  }
  
  
  // Making Peddel Bounce //
  if(ybol-0.5*straal < ypeddel+hpeddel/2 && ybol+0.5*straal > ypeddel-hpeddel/2 && xbol-0.5*straal < xpeddel+wpeddel/2 && xbol-0.5*straal > xpeddel ){
    dxbol = -dxbol;
  }
  
   // Making Peddel2 Bounce //
  if(ybol-0.5*straal < ypeddel2+hpeddel2/2 && ybol+0.5*straal > ypeddel2-hpeddel2/2 && xbol+0.5*straal > xpeddel2-wpeddel2/2 && xbol+0.5*straal < xpeddel2){
    dxbol = -dxbol;
  }
    
  float normalx = 280;
  float normaly = 680;
  float quickx = 610;
  float quicky = 680;
  float hardx = 935;
  float hardy = 680;   
    
  // DRAWING //
  if (gameStart == true){
  image(hm, width/2, height/2);
  }
  
  if(mousePressed){
   if(mouseX>normalx-140 && mouseX<normalx+140 && mouseY>normaly-40 && mouseY<normaly+40){
    gameStart = false;  
  }
    if(mouseX>quickx-140 && mouseX<quickx+140 && mouseY>quicky-40 && mouseY<quicky+40){
    factor = 2;  
    gameStart = false;  
    }
  }
  
  if (gameStart == false){ 
  noCursor();  
  // Darwing Backgound //
  image(bg, width/2, height/2);
  image(myAnimation, width/2, height/2);
    
  if(gameOver == false){  
  // Draw Trampoline
  noStroke();
  image(tr, xpeddel, 650);
  image(tr, xpeddel2, 650);
    
  // Drawing Bol //
  noStroke();
 // rect(xbol, ybol, 100, 100);
 image(ms, xbol, ybol);
  
  // Drawing Peddel
  noStroke();
  image(ka, xpeddel, ypeddel);

  // Draw Peddel2
  noStroke();
  image(kt, xpeddel2, ypeddel2);
  
  // Draw soundicon
  noStroke();

  //Display Score//
  textFont(f,25);
  fill(255);
  text("Score: " + score1, 80, 40);
  text("Score: " + score2, 1120, 40);
  }
  
   // If the game is over
  if (gameOver) {
    textFont(f, 48);
    fill(225);
    text("GAME OVER", width/2, height/2);
  }
}

if(keyPressed){
  if(key == 'p'){
     pauze = true;
    }
}

  float contx = 600;
  float conty = 260;
  float rex = 600;
  float rey = 410;
  float hox = 600;
  float hoy = 550;
  
if(pauze == true && gameStart==false && gameOver==false){
  image(mn, width/2, height/2);
  cursor();
   if(mousePressed){
   if(mouseX>contx-140 && mouseX<contx+140 && mouseY>conty-40 && mouseY<conty+40){
    pauze = false;  
   }
   if(mouseX>rex-140 && mouseX<rex+140 && mouseY>rey-40 && mouseY<rey+40){
    score1=0;
    score2=0;
    ypeddel=585;
    ypeddel2=585;
    dypeddel=0;
    dypeddel2=0;
    xbol=600;
    ybol=350;
    dxbol = 3;
    dybol =2;
    pauze = false;
  }
   if(mouseX>hox-140 && mouseX<hox+140 && mouseY>hoy-40 && mouseY<hoy+40){
    gameStart = true; 
    pauze = false;  
   }
   }
}

}



void serialEvent (Serial p) {
  myString = p.readStringUntil(lf);
  if (myString != null) {
   print(myString);     // it checks the string. print() also line feed included in the string.
    int _values[] = int(split(myString, '\t'));
    if (_values.length-1 == totalSensorCount) {
      for (int i=0; i<= 1; i++)
      {
        values[i] = _values[i];
        print(i + ": " + values[i] + "\t");     // check the values
      }
      println('\n');
    }
  }
}